# Generated by Django 2.1.7 on 2021-03-19 14:58

from django.db import migrations, models
from django.db.models import Q

def create_groups(apps, scheme_editor):
    
    Group = apps.get_model('auth', 'Group')
    Permission = apps.get_model("auth", "Permission")

    groups_info = {
        'Agente SAC': {'tickets': ['typifymodel','newcontactmodel']}, 
        'Administrador SAC': {'tickets': ['categorymodel','processmodel','typifyslackmessagemodel','typifytablesmodel']},
        'Agente Comunicaciones': {'communications':['massivecommunicationsmodel','cyclecommunicationsmodel','triggereventmodel','templateemailmodel',
            'templatewhatsappmodel','templatetextmodel','templatecallmodel','eventemailmodel','eventwhatsappmodel','eventtextmodel',
            'eventcallmodel','emailmodel']},
        'Administrador Comunicaciones':{'communications': ['emailtablesmodel']},
        'Agente Clientes': {'customers': ['customermodel','customerphonemodel','customeremailmodel']},
        'Administrador Clientes': {'customers': ['customertablesmodel']},
        'Agente Leads/Leadlets': {'customers': ['leadcustomermodel','leadletcustomermodel',]},
        'Administrador Leads/Leadlets': {'customers': ['leadtablesmodel','leadlettablesmodel']},
        'Agente Retiro': {'formerCustomers': ['removeequipamentmodel','removeequipamentphotoModel']},
        'Administrador Retiro': {'formerCustomers': ['removeequipamenttablesModel','removeequipamentemailModel','removeequipamentchannelmodel']}
    }

    #Agregar el IF de Agente SAC

    for group_name, permissions in groups_info.items():
        group_instance, p = Group.objects.get_or_create(name=group_name)

        for permission_label, permission_list in permissions.items():

            for permission_name in permission_list:

                permission_query= Permission.objects.filter(content_type__app_label=permission_label).filter(Q(content_type__model=permission_name))

                for permission in permission_query:
                    
                    group_instance.permissions.add(permission)

        if group_name == "Agente SAC": 

            permission_commentaries = Permission.objects.filter(content_type__app_label='communications').filter(Q(content_type__model='internalchatmodel'))
            for permission in permission_commentaries: 
                group_instance.permissions.add(permission)

            permission_leads = Permission.objects.filter(content_type__app_label='customers').filter(Q(content_type__model='leadcustomermodel') | Q(content_type__model='leadletcustomermodel'))
            for permission in permission_leads: 
                group_instance.permissions.add(permission)

def delete_groups(apps, scheme_editor):
    Group = apps.get_model('auth', 'Group')
    group_names = ["Agente SAC","Administrador SAC","Agente Comunicaciones","Administrador Comunicaciones","Agente clientes","Administrador Clientes",
    "Agente Leads/Leadlets","Administrador Leads/Leadlets","Agente Retiro","Administrador Retiro"]
    
    for name in group_names:
        try:
            Group.objects.filter(name=name).delete()
        except:
            pass

class Migration(migrations.Migration):

    dependencies = [
        ('users', '0004_auto_20210319_1058'),
    ]

    operations = [
        migrations.RunPython(create_groups, delete_groups)
    ]
